summaryrefslogtreecommitdiff
path: root/util
diff options
context:
space:
mode:
authorDrashna Jael're <drashna@live.com>2021-12-07 09:27:44 -0800
committerDrashna Jael're <drashna@live.com>2021-12-07 09:27:44 -0800
commit7c18b1c9d3d968ded45e072af3483547c3ec7859 (patch)
treeed7c8a4176033046eacff21228364290b44fcfdb /util
parent43002bdf77ab0f48af6b04e87edcc37f7cb7b905 (diff)
parent6d0a62920410f50d7f6707960ca1ca0c8fd1d1fa (diff)
Merge commit '6d0a62920410f50d7f6707960ca1ca0c8fd1d1fa' into firmware21
Diffstat (limited to 'util')
-rwxr-xr-xutil/chibios_conf_updater.sh103
-rwxr-xr-xutil/install/arch.sh3
-rwxr-xr-xutil/install/debian.sh11
-rwxr-xr-xutil/size_regression.sh79
-rw-r--r--util/udev/50-qmk.rules3
-rwxr-xr-xutil/update_chibios_mirror.sh4
6 files changed, 107 insertions, 96 deletions
diff --git a/util/chibios_conf_updater.sh b/util/chibios_conf_updater.sh
index 5ba8aa677b..a5699ca3cb 100755
--- a/util/chibios_conf_updater.sh
+++ b/util/chibios_conf_updater.sh
@@ -3,6 +3,17 @@
set -eEuo pipefail
umask 022
+#####################
+# You will need to get an older JDK -- JDK 8
+#
+# !!!!!!!! DO NOT INSTALL THIS IF YOU HAVE AN EXISTING JDK OR JRE INSTALLED !!!!!!!!
+#
+# For Debian 10-ish distro's:
+# wget -qO - https://adoptopenjdk.jfrog.io/adoptopenjdk/api/gpg/key/public | sudo apt-key add -
+# sudo add-apt-repository --yes https://adoptopenjdk.jfrog.io/adoptopenjdk/deb/
+# sudo apt-get update && sudo apt-get install adoptopenjdk-8-hotspot
+
+
sinfo() { echo "$@" >&2 ; }
shead() { sinfo "" ; sinfo "---------------------------------" ; sinfo "-- $@" ; sinfo "---------------------------------" ; }
havecmd() { command command type "${1}" >/dev/null 2>&1 || return 1 ; }
@@ -11,8 +22,6 @@ this_script="$(realpath "${BASH_SOURCE[0]}")"
script_dir="$(realpath "$(dirname "$this_script")")"
qmk_firmware_dir="$(realpath "$script_dir/../")"
-declare -A file_hashes
-
export PATH="$PATH:$script_dir/fmpp/bin"
build_fmpp() {
@@ -38,74 +47,13 @@ find_chibi_files() {
local search_path="$1"
shift
local conditions=( "$@" )
- for file in $(find -L "$search_path" -not -path '*/lib/chibios*' -and -not -path '*/lib/ugfx*' -and -not -path '*/util/*' -and \( "${conditions[@]}" \) | sort) ; do
+ for file in $(find -L "$search_path" -not -path '*/lib/chibios*' -and -not -path '*/util/*' -and \( "${conditions[@]}" \) | sort) ; do
if [ -z "$(grep 'include_next' "$file")" ] ; then
echo $file
fi
done
}
-revert_chibi_files() {
- local search_path="$1"
- shead "Reverting ChibiOS config/board files..."
- for file in $(find_chibi_files "$search_path" -name chconf.h -or -name halconf.h -or -name mcuconf.h -or -name board.c -or -name board.h -or -name board.mk -or -name board.chcfg) ; do
- pushd "$search_path" >/dev/null 2>&1
- local relpath=$(realpath --relative-to="$search_path" "$file")
- git checkout upstream/develop -- "$relpath" || git checkout origin/develop -- "$relpath" || true
- popd >/dev/null 2>&1
- done
-}
-
-populate_file_hashes() {
- local search_path="$1"
- shead "Determining duplicate config/board files..."
- for file in $(find_chibi_files "$search_path" -name chconf.h -or -name halconf.h -or -name mcuconf.h -or -name board.c -or -name board.h) ; do
- local key="file_$(clang-format "$file" | sha1sum | cut -d' ' -f1)"
- local relpath=$(realpath --relative-to="$search_path" "$file")
- file_hashes[$key]="${file_hashes[$key]:-} $relpath"
- done
- for file in $(find_chibi_files "$search_path" -name board.mk -or -name board.chcfg) ; do
- local key="file_$(cat "$file" | sha1sum | cut -d' ' -f1)"
- local relpath=$(realpath --relative-to="$search_path" "$file")
- file_hashes[$key]="${file_hashes[$key]:-} $relpath"
- done
-}
-
-determine_equivalent_files() {
- local search_file="$1"
- for K in "${!file_hashes[@]}"; do
- for V in ${file_hashes[$K]}; do
- if [[ "$V" == "$search_file" ]] ; then
- for V in ${file_hashes[$K]}; do
- echo "$V"
- done
- return 0
- fi
- done
- done
- return 1
-}
-
-deploy_staged_files() {
- shead "Deploying staged files..."
- for file in $(find "$qmk_firmware_dir/util/chibios-upgrade-staging" -type f) ; do
- local relpath=$(realpath --relative-to="$qmk_firmware_dir/util/chibios-upgrade-staging" "$file")
- sinfo "Deploying staged file: $relpath"
- for other in $(determine_equivalent_files "$relpath") ; do
- sinfo " => $other"
- cp "$qmk_firmware_dir/util/chibios-upgrade-staging/$relpath" "$qmk_firmware_dir/$other"
- done
- done
-}
-
-swap_mcuconf_f3xx_f303() {
- shead "Swapping STM32F3xx_MCUCONF -> STM32F303_MCUCONF..."
- for file in $(find_chibi_files "$qmk_firmware_dir" -name mcuconf.h) ; do
- sed -i 's#STM32F3xx_MCUCONF#STM32F303_MCUCONF#g' "$file"
- dos2unix "$file" >/dev/null 2>&1
- done
-}
-
upgrade_conf_files_generic() {
local search_filename="$1"
local update_script="$2"
@@ -150,35 +98,8 @@ upgrade_mcuconf_files() {
popd >/dev/null 2>&1
}
-update_staged_files() {
- shead "Updating staged files with ChibiOS upgraded versions..."
- for file in $(find "$qmk_firmware_dir/util/chibios-upgrade-staging" -type f) ; do
- local relpath=$(realpath --relative-to="$qmk_firmware_dir/util/chibios-upgrade-staging" "$file")
- sinfo "Updating staged file: $relpath"
- cp "$qmk_firmware_dir/$relpath" "$qmk_firmware_dir/util/chibios-upgrade-staging/$relpath"
- done
-}
-
havecmd fmpp || build_fmpp
-revert_chibi_files "$qmk_firmware_dir"
-populate_file_hashes "$qmk_firmware_dir"
-
-shead "Showing duplicate ChibiOS files..."
-for K in "${!file_hashes[@]}"; do
- sinfo ${K#file_}:
- for V in ${file_hashes[$K]}; do
- sinfo " $V"
- done
-done
-
-if [ "${1:-}" == "-r" ] ; then
- exit 0
-fi
-
-swap_mcuconf_f3xx_f303
-deploy_staged_files
upgrade_mcuconf_files
upgrade_chconf_files
upgrade_halconf_files
-update_staged_files
diff --git a/util/install/arch.sh b/util/install/arch.sh
index bef98ac37f..33c39212d3 100755
--- a/util/install/arch.sh
+++ b/util/install/arch.sh
@@ -6,7 +6,8 @@ _qmk_install() {
sudo pacman --needed --noconfirm -S \
base-devel clang diffutils gcc git unzip wget zip python-pip \
avr-binutils arm-none-eabi-binutils arm-none-eabi-gcc \
- arm-none-eabi-newlib avrdude dfu-programmer dfu-util
+ arm-none-eabi-newlib avrdude dfu-programmer dfu-util \
+ riscv64-elf-binutils riscv64-elf-gcc riscv64-elf-newlib
sudo pacman --needed --noconfirm -U https://archive.archlinux.org/packages/a/avr-gcc/avr-gcc-8.3.0-1-x86_64.pkg.tar.xz
sudo pacman --needed --noconfirm -S avr-libc # Must be installed after the above, or it will bring in the latest avr-gcc instead
diff --git a/util/install/debian.sh b/util/install/debian.sh
index 57588e371a..3e02919bdd 100755
--- a/util/install/debian.sh
+++ b/util/install/debian.sh
@@ -11,11 +11,18 @@ _qmk_install_prepare() {
_qmk_install() {
echo "Installing dependencies"
- sudo apt-get -yq install \
+ sudo apt-get --quiet --yes install \
build-essential clang-format diffutils gcc git unzip wget zip \
python3-pip binutils-avr gcc-avr avr-libc binutils-arm-none-eabi \
gcc-arm-none-eabi libnewlib-arm-none-eabi avrdude dfu-programmer \
dfu-util teensy-loader-cli libhidapi-hidraw0 libusb-dev
- python3 -m pip install --user -r $QMK_FIRMWARE_DIR/requirements.txt
+ # RISC-V toolchains with picolibc support are only available for distributions based on Debian 11+.
+ if sudo apt-get install --simulate --quiet --yes picolibc-riscv64-unknown-elf gcc-riscv64-unknown-elf binutils-riscv64-unknown-elf > /dev/null 2>&1; then
+ sudo apt-get --quiet --yes install picolibc-riscv64-unknown-elf \
+ gcc-riscv64-unknown-elf \
+ binutils-riscv64-unknown-elf
+ fi
+
+ python3 -m pip install --user -r "$QMK_FIRMWARE_DIR"/requirements.txt
}
diff --git a/util/size_regression.sh b/util/size_regression.sh
new file mode 100755
index 0000000000..988d1d9b5b
--- /dev/null
+++ b/util/size_regression.sh
@@ -0,0 +1,79 @@
+#!/bin/bash
+
+# Copyright 2021 Nick Brassel (@tzarc)
+# SPDX-License-Identifier: GPL-2.0-or-later
+
+set -eEuo pipefail
+
+job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null || sysctl -n hw.ncpu 2>/dev/null || echo 2)
+source_ref="0.11.0"
+dest_ref="develop"
+ignore_ref="master"
+unset skip_zero
+
+function usage() {
+ echo "Usage: $(basename "$0") [-h] [-j <jobs>] [-s <source>] [-d <dest>] [-n] planck/rev6:default"
+ echo " -h : Shows this usage page."
+ echo " -j <threads> : Change the number of threads to execute with. Defaults to \`$job_count\`."
+ echo " -s <source> : Use source commit, branch, tag, or sha1 to start the search. Defaults to \`$source_ref\`."
+ echo " -d <dest> : Use destination commit, branch, tag, or sha1 to end the search. Defaults to \`$dest_ref\`."
+ echo " -i <ignore> : The branch to ignore refs from. Defaults to \`$ignore_ref\`."
+ echo " -n : Skips printing changes if the delta is zero."
+ exit 1
+}
+
+if [[ ${#} -eq 0 ]]; then
+ usage
+fi
+
+while getopts "hj:s:d:i:n" opt "$@" ; do
+ case "$opt" in
+ h) usage; exit 0;;
+ j) job_count="${OPTARG:-}";;
+ s) source_ref="${OPTARG:-}";;
+ d) dest_ref="${OPTARG:-}";;
+ i) ignore_ref="${OPTARG:-}";;
+ n) skip_zero=1;;
+ \?) usage >&2; exit 1;;
+ esac
+done
+
+# Work out the target board
+shift $((OPTIND-1))
+keyboard_target=$1
+
+last_size=0
+last_line=""
+function build_executor() {
+ git rev-list --oneline --no-merges ${source_ref}...${dest_ref} ^${ignore_ref} | while IFS= read -r line ; do
+ revision=$(echo $line | cut -d' ' -f1)
+
+ make distclean >/dev/null 2>&1
+ git checkout $revision >/dev/null 2>&1 || { echo "Failed to check out revision ${revision}" >&2 ; exit 1 ; }
+ make -j${job_count} $keyboard_target >/dev/null 2>&1 || true
+ file_size=$(arm-none-eabi-size .build/*.elf 2>/dev/null | awk '/elf/ {print $1}' 2>/dev/null || true)
+
+ if [[ "$last_size" == 0 ]] ; then last_size=$file_size ; fi
+ if [[ -z "$file_size" ]] ; then file_size=0 ; fi
+
+ if [[ -n "$last_line" ]] ; then
+ size_delta=$(( $last_size - $file_size ))
+ if { [[ -n "${skip_zero:-}" ]] && [[ $size_delta -ne 0 ]] ; } || [[ $file_size -eq 0 ]] ; then
+ printf "Size: %8d, delta: %+6d -- %s\n" "$last_size" "$size_delta" "$last_line"
+ fi
+ fi
+
+ last_size=$file_size
+ last_line=$line
+ done
+
+ if [ -n "$last_line" ] ; then
+ size_delta=0
+ printf "Size: %8d, delta: %+6d -- %s\n" "$last_size" "$size_delta" "$last_line"
+ fi
+}
+
+# The actual execution of all the builds needs to be the last command in the entire script
+# - During builds, this script file will disappear, so we need the entire script to be
+# loaded into the script interpreter at the time of execution. Do not refactor.
+build_executor
diff --git a/util/udev/50-qmk.rules b/util/udev/50-qmk.rules
index db27d4dc81..57806f9df0 100644
--- a/util/udev/50-qmk.rules
+++ b/util/udev/50-qmk.rules
@@ -33,6 +33,9 @@ SUBSYSTEMS=="usb", ATTRS{idVendor}=="16c0", ATTRS{idProduct}=="05dc", TAG+="uacc
SUBSYSTEMS=="usb", ATTRS{idVendor}=="03eb", ATTRS{idProduct}=="6124", TAG+="uaccess", ENV{ID_MM_DEVICE_IGNORE}="1"
# Caterina (Pro Micro)
+## pid.codes shared PID
+### Keyboardio Atreus 2 Bootloader
+SUBSYSTEMS=="usb", ATTRS{idVendor}=="1209", ATTRS{idProduct}=="2302", TAG+="uaccess", ENV{ID_MM_DEVICE_IGNORE}="1"
## Spark Fun Electronics
### Pro Micro 3V3/8MHz
SUBSYSTEMS=="usb", ATTRS{idVendor}=="1b4f", ATTRS{idProduct}=="9203", TAG+="uaccess", ENV{ID_MM_DEVICE_IGNORE}="1"
diff --git a/util/update_chibios_mirror.sh b/util/update_chibios_mirror.sh
index 83aee22817..0bf648ebfd 100755
--- a/util/update_chibios_mirror.sh
+++ b/util/update_chibios_mirror.sh
@@ -7,10 +7,10 @@
chibios_branches="trunk stable_20.3.x stable_21.6.x"
# The ChibiOS tags to mirror
-chibios_tags="ver20.3.1 ver20.3.2 ver20.3.3 ver21.6.0"
+chibios_tags="ver20.3.1 ver20.3.2 ver20.3.3 ver20.3.4 ver21.6.0"
# The ChibiOS-Contrib branches to mirror
-contrib_branches="chibios-20.3.x"
+contrib_branches="chibios-20.3.x chibios-21.6.x"
################################
# Actions